//============================================================================
//	aisa31bs.pas
//
//	aISA-P31B
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.11 Date 1999/08/23
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//============================================================================
unit aisa31bs;

interface

uses
	Windows, Messages, SysUtils, Forms, aisa31bw;

const
	szTitle = 'Sample';
	szP31B	= 'aISA-P31B';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(szBuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

//============================================================================
//	۸т̊Jn
//============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
	wLogSlot:	Word;								// ޲̘_ۯĔԍi[
	Ri:		TAISA31BRESOURCE;		// ؿ
	dwDLLVer, dwDriverVer: DWord;
	cbDat:		Byte;
	bResult:	Boolean;						// 
	szBuf:		String;
begin
	//-------------------------------------------------
	// aisa31b.dll ̎gp錾
	//-------------------------------------------------
	if Aisa31bwDllOpen() = False then begin
		ErrorMessage(AISA31B_SLOT_AUTO);
		Exit;											// aisa31b.dll ۰ނɎs܂
	end;
	//-------------------------------------------------
	// ްޮݔԍ\
	// aISA-P31B DLL,ײްްޮݔԍ擾
	//-------------------------------------------------
	if Aisa31bwGetVersion(dwDLLVer, dwDriverVer) = False then begin
		ErrorMessage(AISA31B_SLOT_AUTO);
		Exit;
	end;

	szBuf := Format('GetVersion'#10 +
		    	'DLL Version'#09+ ': %08xH'#10 +
		    	'Driver Version'#09+ ': %08xH',
		    	[dwDLLVer, dwDriverVer]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// aISA-P31B̎gp錾
	//-------------------------------------------------
	wLogSlot := AISA31B_SLOT_AUTO;			// gp޲T܂B
	bResult := Aisa31bwCreate(wLogSlot);		// ꍇA̎޲̘_ۯĔԍi[܂B
	if bResult = False then begin			// ޲܂B
		ErrorMessage(AISA31B_SLOT_AUTO);
		Exit;
	end;
	szBuf := Format('aISA-P31B Created'#10#10 +
		    	'LogSlot: %2d'
		    	,[wLogSlot]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// ؿ擾
	//-------------------------------------------------
	if Aisa31bwGetResource(wLogSlot, Ri) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	szBuf := Format( 'Board Name'#09 + ': %s'#10 +
		    	 'IO Address'#09 + ': %04xH-%04xH' ,
		    	 [szP31B,
		    	Ri.dwIOPortBase[1],
		    	Ri.dwIOPortBase[1] + Ri.dwIOPortLength[1] - 1]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// Port 1 ɔCӂްo
	//-------------------------------------------------
	cbDat := Byte($AA);
	if Aisa31bwOutPort(wLogSlot, AISA31B_PORT_1, cbDat) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	szBuf := Format( 'Port 1 փf[^o'#10 +
			 'Port 1 Out Data: %02xH',
			 [cbDat]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// Port 1 ްǂݍ
	//-------------------------------------------------
	cbDat := Byte($00);
	if Aisa31bwInPort(wLogSlot, AISA31B_PORT_1, cbDat) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	szBuf := Format( 'Port 1 f[^'#10 +
			 'Port 1 In Data: %02xH',
			 [cbDat]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// aISA-P31B̎gpJ
	//-------------------------------------------------
	if Aisa31bwClose(wLogSlot) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	ResultMessage('aISA-P31B Closed');
	//-------------------------------------------------
	// aisa31b.dll ̎gpJ
	//-------------------------------------------------
	if Aisa31bwDllClose() = False then begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;
	end;
end;

//============================================================================
// ʂ\
//============================================================================
procedure TForm1.ResultMessage(szBuf: String);
begin
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//============================================================================
// װүނ\
//============================================================================
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	szBuf: String;
begin
	dwRes := Aisa31bwGetLastError(wLogSlot);
	case dwRes of
        	AISA31B_ERR_SYSTEM:
			szBuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);
		AISA31B_ERR_WRAPDLL:
                        szBuf := 'DLL Load error';
	else
			szBuf := Format('aISA-P31B error'#10#10'Error code: %08xH',[dwRes]);
        end;
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.

