/*============================================================================
//	aisa31bw.c
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.11 Date 1999/10/14
//
//==========================================================================*/
#include <windows.h>
#include <tchar.h>
#include "aisa31bw.h"	/* aISA-P31B */

/*-------------------------------------
// (STATIC)ϐȂ
//-----------------------------------*/
static BOOL Aisa31bwGetDllExportFunc();
static HMODULE hDLL = NULL;

/* DLL ߰Ċ֐ڽ̊i[ϐ */
static FARPROC pAisa31bGetVersion = NULL;
static FARPROC pAisa31bCreate = NULL;
static FARPROC pAisa31bClose = NULL;
static FARPROC pAisa31bGetResource = NULL;
static FARPROC pAisa31bInPort = NULL;
static FARPROC pAisa31bOutPort = NULL;
static FARPROC pAisa31bGetLastError = NULL;
static FARPROC pAisa31bGetSwitchValue = NULL;

/*============================================================================
// 	  aisa31b.dll۰(۰ގʹװƂ)	
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Aisa31bwDllOpen()
{
	BOOL	Result = FALSE;
	if (hDLL == NULL){
		hDLL = (HMODULE)LoadLibrary(AISA31B_DLL_NAME);
		if (hDLL != NULL){
			Result = Aisa31bwGetDllExportFunc();
			if (TRUE != Result)
				Aisa31bwDllClose();	/* DLL֐擾ɎŝDLL۰ */
		}
	}
	return Result;
}
/*============================================================================
// 	  aisa31b.dll۰(۰ގʹװƂ)
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Aisa31bwDllClose()
{
	BOOL	Result = FALSE;
	if (hDLL != NULL){
		Result = FreeLibrary(hDLL);
		if (TRUE == Result)
			hDLL = NULL;
	}
	return Result;
}
/*============================================================================
// 	  aISA-P31B DLL,޲ײްްޮݔԍ擾
// 	  pdwDllVersion		DLLްޮݔԍi[̈ւ߲
//		  pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Aisa31bwGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pAisa31bGetVersion)(pdwDllVersion, pdwDriverVersion);
	return Result;
}
/*============================================================================
// 	  aISA-P31B̔Cӂ޲̎gp錾
// 	  pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Aisa31bwCreate(PWORD pwLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pAisa31bCreate)(pwLogSlot);
	return Result;
}
/*============================================================================
// 	  aISA-P31B̔Cӂ޲̎gpJ
// 	  wLogSlot ޲̘_ۯĔԍ
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Aisa31bwClose(WORD wLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pAisa31bClose)(wLogSlot);
	return Result;
}
/*============================================================================
// 	  w޲ؿ擾
// 	  wLogSlot	ؿ擾޲̘_ۯĔԍ
//		  pResInfo	ؿi[\߲̂
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Aisa31bwGetResource(WORD wLogSlot, PAISA31BR pResInfo)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pAisa31bGetResource)(wLogSlot, pResInfo);
	return Result;
}
/*============================================================================
// 	  Cӂ߰Ăް
// 	  wLogSlot	͂޲̘_ۯĔԍ
//		  dwLogPort	͂_߰
//		  pbInValue ްi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Aisa31bwInPort(WORD wLogSlot, DWORD dwLogPort, PBYTE pbInValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pAisa31bInPort)(wLogSlot, dwLogPort, pbInValue);
	return Result;
}
/*============================================================================
// 	  Cӂ߰Ăްo
// 	  wLogSlot	o͂޲̘_ۯĔԍ
//		  dwLogPort	o͂_߰
//		  bOutValue o͂ް
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Aisa31bwOutPort(WORD wLogSlot, DWORD dwLogPort, BYTE bOutValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pAisa31bOutPort)(wLogSlot, dwLogPort, bOutValue);
	return Result;
}
/*============================================================================
// 	  aISA-P31B̴װ
// 	  wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//==========================================================================*/
DWORD Aisa31bwGetLastError(WORD wLogSlot)
{
	if (NULL == hDLL)
		return AISA31B_ERR_WRAPDLL;
	else
		return (*pAisa31bGetLastError)(wLogSlot);
}
/*----------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  TRUE
//		  s FALSE
//--------------------------------------------------------------------------*/
static BOOL Aisa31bwGetDllExportFunc()
{
	/* Aisa31bGetVersion ̱ڽ擾 */
	pAisa31bGetVersion = GetProcAddress(hDLL, _T("Aisa31bGetVersion"));
	if (pAisa31bGetVersion == NULL)
		return FALSE;

	/* Aisa31bCreate ̱ڽ擾 */
	pAisa31bCreate = GetProcAddress(hDLL, _T("Aisa31bCreate"));
	if (pAisa31bCreate == NULL)
		return FALSE;

	/* Aisa31bClose ̱ڽ擾 */
	pAisa31bClose = GetProcAddress(hDLL, _T("Aisa31bClose"));
	if (pAisa31bClose == NULL)
		return FALSE;

	/* Aisa31bGetResource ̱ڽ擾 */
	pAisa31bGetResource = GetProcAddress(hDLL, _T("Aisa31bGetResource"));
	if (pAisa31bGetResource == NULL)
		return FALSE;

	/* Aisa31bInPort ̱ڽ擾 */
	pAisa31bInPort = GetProcAddress(hDLL, _T("Aisa31bInPort"));
	if (pAisa31bInPort == NULL)
		return FALSE;

	/* Aisa31bOutPort ̱ڽ擾 */
	pAisa31bOutPort = GetProcAddress(hDLL, _T("Aisa31bOutPort"));
	if (pAisa31bOutPort == NULL)
		return FALSE;

	/* Aisa31bGetLastError ̱ڽ擾 */
	pAisa31bGetLastError = GetProcAddress(hDLL, _T("Aisa31bGetLastError"));
	if (pAisa31bGetLastError == NULL)
		return FALSE;

	return TRUE;	/* SĂ DLL ߰Ċ֐ڽ擾 */
}
